##############################################################################
#   ____________________________________________________________________     #
#   ,       _____   __   ______   _____   _____    _____   ______      ,     #
#    ,     |  ___| |  | |_    _| |  ___| |  __ \  /     \ |_    _|    ,      #
#     ,    |___  | |  |   |  |   |  ___| |  __ <  |  |  |   |  |     ,       #
#      ,   |_____| |__|   |__|   |_____| |_____/  \_____/   |__|    ,        #
#       ,---------------------GLFTPD-EDITION-----------------------,         #
#        ,   CODER: DaRKHeaRT                                     ,          #
#         ,  VERSION: sitebot-glftpd.tcl v2.2                    ,           #
#          ,____________________________________________________,            #
#           ,..this.is.a.product.of.the.elite.scripting.team...,             #
#            ,.............#scriptings.on.efnet...............,              #
#                                                                            #
##############################################################################
#                                                                            #
#   Script   sitebot-glftpd.tcl                                             #
#   Coder    DaRKHeaRT (rhett@lotus-net.ch) of MOONSHINE/TST/PCY            #
#   Version  2.2 -glftpd edition-                                           #
#                                                                            #
#   This TCL does not need to be modified in anyway. Specific preferences    #
#   are set in sitebot-glftpd.config which will be generated if you dont     #
#   have one in your scritps dir or updated if your config file is old.      #
#                                                                            #
#   READ sitebot-glftpd.readme BEFORE DOING ANYTHING!                        #
#                                                                            #
##############################################################################
#                                                                            #
#   Copyright (C) 1998 - 2000 DaRKHeaRT                                      #
#                                                                            #
#   This program is free software; you can redistribute it and/or modify     #
#   it under the terms of the GNU General Public License as published by     #
#   the Free Software Foundation; either version 2 of the License, or        #
#   (at your option) any later version.                                      #
#                                                                            #
#   This program is distributed in the hope that it will be useful,          #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of           #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            #
#   GNU General Public License for more details.                             #
#                                                                            #
##############################################################################

   #######################################################################
   #       __  __   _____   ______   __   __   __   __  __   _____       #
   #      |  \|  | /     \ |_    _| |  |_|  | |  | |  \|  | /  ___\      #
   #      |      | |  |  |   |  |   |   _   | |  | |      | |  \_ \      #
   #      |__|\__| \_____/   |__|   |__| |__| |__| |__|\__| \_____/      #
   #          ______   _____      _____   ____    __   ______            #
   #         |_    _| /     \    |  ___| |    \  |  | |_    _|           #
   #           |  |   |  |  |    |  ___| |  |  | |  |   |  |             #
   #           |__|   \_____/    |_____| |____/  |__|   |__|             #
   #             _____   _____   __      _____   __    __                #
   #            |  __ \ |  ___| |  |    /     \ |  |/\|  |               #
   #            |  __ < |  ___| |  |__  |  |  | |        |               #
   #            |_____/ |_____| |_____| \_____/  \__/\__/                #
   #                                                                     #
   #######################################################################

package require FTP

proc init {} {
global enabled sitename sitein output prefix dcc_prefix logfile dirlog_testchans
global sonjoin todaylink sitedir site today timer invitechan devices deny_post block_size
global glconf glftpddir gllog glusers glxferlog glbindir currentconfigversion
        set currentconfigversion 2.1
        set enabled(announce) 1
        set enabled(announce_newdir) 1
        set enabled(announce_newzip) 1
        set enabled(announce_sfv) 1
        set enabled(announce_complete) 0
        set enabled(announce_pre) 0
        set enabled(announce_delete) 0
        set enabled(announce_nuke) 1
        set enabled(announce_unnuke) 1
        set enabled(announce_autonuke) 0
        set enabled(announce_race) 0
        set enabled(announce_incomplete) 0
        set enabled(announce_deleted) 0
        set enabled(stats) 1
        set enabled(dcc) 1
        set enabled(site_invite) 0
        set enabled(auto_bw) 0
        set enabled(auto_wktop) 0
        set timer(wktop) 360
        set timer(bw) 60
        set timer(chk) 5
        set timer(today) 1
        set invitechan "#msn"
        set sitename "My Site Name"
        set sitein "MSN"
        set output "1"
        set prefix "!msn"
        set dcc_prefix "s"
        set logfile "~/msn.log"
        set dirlog_testchans {#msn}
        set sonjoin 1
        set site(ip) "localhost"
        set site(port) "31337"
        set site(user) "!msnbot"
        set site(pass) "m1dsdi27"
        set glconf /etc/glftpd.conf
        set today "/today"
        set glftpddir /glftpd
        set gllog /glftpd/ftp-data/logs/glftpd.log
        set glusers /glftpd/ftp-data/users
        set glbindir /glftpd/bin
        set pnc 0
        set devices {/dev/hda2 /dev/md0}
        set deny_post {*demo* *sample* *cover* *kbps*}
        set block_size 1
}

proc update {} {
  global enabled sitename sitein output prefix dcc_prefix logfile dirlog_testchans
  global sonjoin todaylink sitedir site today timer invitechan devices deny_post block_size
  global glconf glftpddir gllog glusers glxferlog glbindir currentconfigversion
  if ![info exists sitedir] {
    set sitedir(vcd) /site/vcd/
    set sitedir(iso) /site/iso/
    set sitedir(mp3) /site/mp3/
    set sitedir(0day) /site/0day/
    set sitedir(request) /site/request/
  }
  set file [open sitebot-glftpd.config w]
  puts $file "##### SITE SPECIFIC SETTINGS AND PREFERENCES #####"
  puts $file ""
  puts $file "set configversion $currentconfigversion;                 # dont touch this line."
  puts $file ""
  puts $file "set enabled(stats) $enabled(stats);                # Site Stats Section     (0=off/1=on)"
  puts $file "set enabled(dcc) $enabled(dcc);                  # Site DCC Commands      (0=off/1=on)"
  puts $file ""
  puts $file "set enabled(announce) $enabled(announce);             # Announce (0=off/1=on)"
  puts $file "set enabled(announce_newdir) $enabled(announce_newdir); # Announce new dirs (0=off/1=on)"
  puts $file "set enabled(announce_newzip) $enabled(announce_newzip); # Announce expected amount of disks to come on ZIP  (0=off/1=on)"
  puts $file "set enabled(announce_sfv) $enabled(announce_sfv);         # Announce SFV file upload - expected amount of disks and filename (0=off/1=on)"
  puts $file "set enabled(announce_pre) $enabled(announce_pre);      # Announce Pre's (0=off/1=on)"
  puts $file "set enabled(announce_complete) $enabled(announce_complete);    # Announce Completion of files in Dir applies to zip files (0=off/1=on)"
  puts $file "set enabled(announce_delete) $enabled(announce_delete);      # Announce Removal of Dir (0=off/1=on)"
  puts $file "set enabled(announce_nuke) $enabled(announce_nuke);        # Announce Nuked dirs (0=off/1=on)"
  puts $file "set enabled(announce_unnuke) $enabled(announce_unnuke);      # Announce Unnuked dirs (0=off/1=on)"
  puts $file "set enabled(announce_autonuke) $enabled(announce_autonuke);    # BLiNKY's Autonuke Feature (0=off/1=on)"
  puts $file "set enabled(announce_race) $enabled(announce_race);    # v-mans race Feature (0=off/1=on)"
  puts $file "set enabled(announce_deleted) $enabled(announce_deleted);    # announce barkeeps autodel script (0=off/1=on)"
  puts $file "set enabled(announce_incomplete) $enabled(announce_incomplete); # v-mans announce Incomplete Dirs"
  puts $file ""
  puts $file "set enabled(site_invite) $enabled(site_invite); #enable site invite.. ie \"site invite user\" (0=off/1=on)"
  puts $file "set invitechan $invitechan; #channel to invite to on \"site invite nickname\""
  puts $file ""
  puts $file "set enabled(auto_bw) $enabled(auto_bw);        # Enable Auto Bandwidth announcer (0=off/1=on)"
  puts $file "set timer(bw) $timer(bw);        # Announce Bandwidth every x minutes"
  puts $file "set enabled(auto_wktop) $enabled(auto_wktop);        # Enabled Auto Weektop Announcer (0=off/1=on)"
  puts $file "set timer(wktop) $timer(wktop);        # Announce Weektop Stats every x minutes"
  puts $file ""
  puts $file "set sitename \"$sitename\";        # Full Site Name"
  puts $file "set sitein \"$sitein\";                  # Short Site Name"
  puts $file "set output \"$output\";                    # Notices = 0 or Private Messages = 1"
  puts $file "set prefix \"$prefix\";                 # prefix before public commands."
  puts $file "set dcc_prefix \"$dcc_prefix\";                # Letter before commands in dcc chat"
  puts $file "set logfile \"$logfile\";           # Log File of changes made through Bot"
  puts $file "set dirlog_testchans \"$dirlog_testchans\";        # Channels to announce to Seperate by space"
  puts $file "set sonjoin $sonjoin;                       # show onjoin in pubchans (0=off/1=on)"
  puts $file "set timer(chk) $timer(chk);                      # check for new releases every x seconds"
  puts $file "set today $today;                    # today dir location relative to within ftp"
  puts $file ""
  puts $file "set devices \"$devices\"; # Hard Disks you wanted counted in !sitefree command"
  puts $file "set deny_post \"$deny_post\"; # dirs you want to not announce"
  puts $file "set block_size $block_size; # the dominant block-size in `df -k'" 
  puts $file ""
  puts $file "# Site Stat Sections, note the name of the section will effect the type ie"
  puts $file "# !prefix vcd wkup !prefix iso wkup just copy/paste this line or delete lines"
  puts $file "# relative to how many stats sections you have on your site."
  puts $file "# These dirs are set relative to once you are logged onto the ftp ie no /glftpd"
  puts $file ""
  foreach sitedirtype [array names sitedir] {
    puts $file "set sitedir($sitedirtype) \"$sitedir($sitedirtype)\""
  }
  puts $file ""
  puts $file "# You need to make a login on your site with full siteop access if intending"
  puts $file "# to allow proper use of dcc section or just standard flags will do if only"
  puts $file "# using stats section. nuke flags required if you want autonuke.. best if you"
  puts $file "# ust make a login with siteop access and all the flags 14ABCDEFGH etc."
  puts $file ""
  puts $file "set site(ip) $site(ip);              # Site ip"
  puts $file "set site(port) $site(port);                # Site Port"
  puts $file "set site(user) $site(user);              # Login Name"
  puts $file "set site(pass) $site(pass);             # Password"
  puts $file ""
  puts $file "# ADVANCE CONFIG... I SUGGEST YOU DONT TOUCH"
  puts $file ""
  puts $file "set glconf $glconf"
  puts $file "set glftpddir $glftpddir"
  puts $file "set gllog $gllog"
  puts $file "set glusers $glusers"
  puts $file "set glbindir $glbindir"
  puts $file ""
  puts $file "set pnc 0"
  close $file
  exec mv sitebot-glftpd.config scripts
  putlog "Done."
}

init

if {![file exists scripts/sitebot-glftpd.config]} {
  putlog "SITEBOT: config file not found creating one now..."
  putlog "SITEBOT: recommend that you edit your conf asap..."
  update
}

source scripts/sitebot-glftpd.config

if {![info exists configversion]} {
  global configversion
  putlog "SITEBOT: cant read config version number... some idiot deleted it from the conf file :)"
  putlog "SITEBOT: updating conf file. default values used for missing vars.."
  set configversion 2.2
  update
}

if {$configversion < $currentconfigversion} {
  putlog "SITEBOT: config file is old updating... default values been used for"
  putlog "SITEBOT: missing variables strongly recommend you edit your conf.."
  update
}

if {$configversion == $currentconfigversion} {
  putlog "SITEBOT: config version matchs tcl version! Variables Read Succesfully!"
}

if {$configversion > $currentconfigversion} {
  putlog "SITEBOT: config version is newer then tcl... no changes made"
  putlog "SITEBOT: possibility for errors due to version mismatch"
}

putlog "$sitein.. BOT UP.. Fingers Crossed.. Loading Sections"

# CONNECT THE BOT

#if { ![info exists enabled(stats)] && ![info exists enabled(dcc)] } {

        global site
        utimer 5 "FTP::Open $site(ip) $site(port) $site(user) $site(pass)"
        timer 1 pwdtimer
        proc pwdtimer {} {
                timer 1 pwdtimer
                FTP::Pwd
        }
#}

# GENERAL

set ver "SiteBot-v2.2-glftpd-edition"
set flag6 S
set flag7 N
set flag8 C

proc u {} {return \037};                  #underline
proc r {} {return \026};                  #reverse
proc b {} {return \002};                  #bold
proc c {} {return \003};                  #color
proc a {} {return \001}

proc putnot { nick not } { putserv "NOTICE $nick : $not"}
proc putmsg { nick not } { putserv "PRIVMSG $nick : $not"}
proc putnm { nick not } {global output ; if {$output == "1"} { putmsg $nick $not ; return 0 } ; putnot $nick $not ; return 0 }

#######################################################
################### AUTORUN SCRIPT ####################
#######################################################

#BANDWIDTH ANNOUNCE
if $enabled(auto_bw) {
timer $timer(bw) "auto_bandwidth"
proc auto_bandwidth {} {
        global sitein dirlog_testchans glftpddir
        set res [exec $glftpddir/bin/bandwidth]
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] BANDWIDTH-\002 $res"}}
        }
        if {[lsearch [timers] "* auto_bandwidth *"] == -1} {
           timer $timer(bw) "auto_bandwidth"
        }
#}

#WEEKTOPSTATS
if $enabled(auto_wktop) {
timer $timer(wktop) "auto_weektopstats"
proc auto_weektopstats {} {
        global sitein dirlog_testchans glftpddir
        set res [exec $glftpddir/bin/weektop]
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] WEEKTOPANNOUNCE-\002 $res"}}
        }
        if {[lsearch [timers] "* auto_weektopstats *"] == -1} {
           timer $timer(wktop) "auto_weektopstats"
        }
#}

#######################################################
################## ANNOUNCE SCRIPT ####################
#######################################################

if $enabled(announce) {

proc sndall {msg} {
  global dirlog_testchans
  putallbots "sndall $msg"
  foreach chan $dirlog_testchans { putserv "PRIVMSG $chan :$msg" }
}

proc rel {fpath} {
  set split [split $fpath /]
  set ll [llength $split]
  if {$ll < 3} {return 0}
  set rel [lindex $split [expr $ll -1]]
  set loc [lindex $split [expr $ll -2]]
  return "\{$loc\} \{$rel\}"
}

proc fixsize {size} {
  if {$size == ""} {return [b][b]}
  if {$size >= 1048576} {
    return "[round [expr $size / 1048576.0] 2]GB"
  } elseif {$size >= 1024.0} {
    return "[round [expr $size / 1024.0] 2]MB"
  } else {
    return "$size K"
  }
}

proc round {num dec} {
  if {[string first . $num] != -1} {
    set num [string range $num 0 [expr [string first . $num] + $dec]]
    set num [fixlenc $num [expr [string first . $num] + $dec + 1] 0]
    return $num
  } else {
    append num .
    set num [fixlenc $num [expr [string first . $num] + $dec + 1] 0]
    return $num
  }
}

proc fixlenc {txt len char} {
while {[string length $txt] < $len} {append txt $char}
return $txt}

proc fixlenf {txt len} {
while {[string length $txt] < $len} {set txt " $txt"}
return $txt}

proc dirname  {fpath} {
  set spl [split $fpath /]
  set ll [llength $spl]
  if { $ll < 3 } { return "" }
  set args [join [lrange $spl 0 [expr $ll-2]] /]
  return $args
  }

proc nukechk {nukepath p} {
global glftpddir sitein
        set fd [open "|$glftpddir/bin/autonuke $p"]
        if {![eof $fd]} { set pq [gets $fd] }
        close $fd         
        if { $pq == "Can not open DUPELOG" } { putlog "ERROR OPENING DUPELOG" ; set pq "" }
        if { $pq != "" } {
                  putlog "***** AUTONUKING $p (REUP $pq)"
                  sndall "\[[b]$sitein[b]\] [b]AUTONUKE:[b] $p ----> (REUP-$pq)"
                  FTP::Cd $nukepath
                  FTP::Site "nuke $p 1 (REUP--$pq)"
        }
}

proc scanlog {} {global sitein gllog dirlog_testchans timer lastoct pnc
global new_release enabled deny_post
utimer $timer(chk) "scanlog"
  if {[file size $gllog] == $lastoct} {return 0}
  if {[file size $gllog] < $lastoct} {set lastoct 0}
  if {[catch {set of [open $gllog r]}] != 0} {return 0}
  seek $of $lastoct
  while {![eof $of]} {
    set line [gets $of]
    if {$line == ""} {continue}
    if {[catch {set date [clock scan [lrange $line 0 4]]}] != 0} {continue}
    set type [lindex $line 5]
    set now [clock format [clock seconds] -format "%H:%M"]
    set args [lrange $line 6 end]
    switch $type {
      NEWDIR: {
     #NEWDIR: <path> <user> <user_grp> <user_tag>
       if $enabled(announce_newdir) {
        foreach skip $deny_post {if {[string match "$skip" [string tolower [lindex $args 0]]]} { close $of ; snop ; set lastoct [file size $gllog] ; return 0 } }
        set pf [rel [lindex $args 0]]
        if {$pf == 0} {continue}
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set user [lindex $args 1]
        set group [lindex $args 2]
        set tagline [lindex $args 3]
        if {$group == ""} {set group "NoGroup"}
        putlog "\[[b]$sitein[b]\] [b]NEW RELEASE[b] -$path- [b]$rel[b] at [b]$now[b] by [b]$user[b] from [b]$group[b] \[$tagline\]"
        sndall "\[[b]$sitein[b]\] [b]NEW RELEASE[b] -$path- [b]$rel[b] at [b]$now[b] by [b]$user[b] from [b]$group[b] \[$tagline\]" 
        if $enabled(announce_autonuke) {[nukechk $path $rel]}
        if {$pnc == 1} {nukecheck $rel}
        }
       }
      COMPLETENESS_STATUS: {
     #COMPLETENESS_STATUS: <amount_missing>
       if $enabled(announce_incomplete) {
        if {[lindex $args 0] > 0} {
        putlog "\[[b]$sitein[b]\] [b]NEW RELEASE[b] -$path- [b]$rel[b] at [b]$now[b] by [b]$user[b] from [b]$group[b] \[$tagline\]"
        sndall "[b]$sitein[b] INCOMPLETE: (use \"SITE INC\" to view the list) - (missing:  [lindex $args 0] cds)"
        }
       }
      }
      COMPLETE: {
     #COMPLETE: <winner> <count> <totalcount> <winnersize> <totalsize> <completedby> <kbs>
       if $enabled(announce_complete) {
        foreach skip $deny_post { if {[string match "$skip" [string tolower [lindex $args 0]]]} { close $of ; snop ; set lastoct [file size $gllog] ; return 0 } }
        set pf [rel [lindex $args 0]]
        if {$pf == 0} {continue}
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set winner [lindex $args 1]
        set count [lindex $args 2]
        set totalcount [lindex $args 3]
        set winnersize [lindex $args 4]
        set totalsize [lindex $args 5]
        set completedby [lindex $args 6]
        set kps [lindex $args 7]
        putlog "\[[b]$sitein[b]\] [b]COMPLETED:[b] -$path- [b]$rel ($totalsize)[b] completed by [b]$completedby[b] won by [b]$winner (Total: $winnersize)[b] with [b]$count[b] of [b]$totalcount [b]disk(s) uploaded"
        sndall "\[[b]$sitein[b]\] [b]COMPLETED:[b] -$path- [b]$rel ($totalsize)[b] completed by [b]$completedby[b] won by [b]$winner (Total: $winnersize)[b] with [b]$count[b] of [b]$totalcount [b]disk(s) uploaded"
        if {$pnc == 1} {nukecheck $rel}
        }
       }
       COMPLETES: {
      #COMPLETES: <winner> <count> <totalcount> <winnersize> <totalsize> <completedby> <kbs>
       if $enabled(announce_complete) {
        foreach skip $deny_post { if {[string match "$skip" [string tolower [lindex $args 0]]]} { close $of ; snop ; set lastoct [file size $gllog] ; return 0 } }
        set pf [rel [lindex $args 0]]
        if {$pf == 0} {continue}
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set winner [lindex $args 1]
        set count [lindex $args 2]
        set totalcount [lindex $args 3]
        set winnersize [lindex $args 4]
        set totalsize [lindex $args 5]
        set kps [lindex $args 6]
        putlog "\[[b]$sitein[b]\] [b]COMPLETED:[b] -$path- [b]$rel ($totalsize)[b] completed and won by [b]$winner (Total: $winnersize)[b] with [b]$count[b] of [b]$totalcount [b]disk(s) uploaded"
        sndall "\[[b]$sitein[b]\] [b]COMPLETED:[b] -$path- [b]$rel ($totalsize)[b] completed and won by [b]$winner (Total: $winnersize)[b] with [b]$count[b] of [b]$totalcount [b]disk(s) uploaded"
        if {$pnc == 1} {nukecheck $rel}
        }
       }
      HALFWAY: {
     #HALFWAY: <winner> <count> <totalcount> <winnersize> <totalsize> <racingwith>
       if $enabled(announce_halfway) {
        set pf [rel [lindex $args 0]]
        if {$pf == 0} {continue}
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set winner [lindex $args 1]
        set count [lindex $args 2]
        set totalcount [lindex $args 3]
        set winnersize [lindex $args 4]
        set totalsize [lindex $args 5]
        set racingwith [lrange $args 6 end]
        putlog "\[[b]$sitein[b]\] [b]UPDATE[b] -$path- [b]$rel[b] Currrently [b]$winner[b] is leading the race against [b]$racingwith[b] with [b]$winnersize[b] in $count of $totalcount files"
        sndall "\[[b]$sitein[b]\] [b]UPDATE[b] -$path- [b]$rel[b] Currrently [b]$winner[b] is leading the race against [b]$racingwith[b] with [b]$winnersize[b] in $count of $totalcount files"                                     
        if {$pnc == 1} {nukecheck $rel}
        }
       }
      RACE: {
     #RACE: <path> <user_winner> <user_grp> <user_amount> <user_files> <grp_winner> <grp_amount> <grp_files> <total_amount> <total_files> <total_duration> <total_user_racres> <total_group_racers>
       if $enabled(announce_race) {
        foreach skip $deny_post { if {[string match "$skip" [string tolower [lindex $args 0]]]} { close $of ; snop ; set lastoct [file size $gllog] ; return 0 } }
        set pf [rel [lindex $args 0]]
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        if {[lindex $args 10] == 0} {set duration "" } else { set duration ", [format "%.2f" "[expr [lindex $args 10] / 60.0]"] minutes" }
        putlog "[b]$sitein[b] WINNERS: [b]$rel[b] - (user:  [b][lindex $args 1]@[lindex $args 2][b] of [lindex $args 11] racers, [lindex $args 4] files at [format "%.0f" [expr [lindex $args 3] / 1024]]MB) - (group:  [b][lindex $args 5][b] of [lindex $args 12] racers, [lindex $args 7] files at [format "%.0f" [expr [lindex $args 6] / 1024]]MB) - \[total:  [lindex $args 9] files at [format "%.0f" [expr [lindex $args 8] / 1024]]MB$duration\]"
        sndall "[b]$sitein[b] WINNERS: [b]$rel[b] - (user:  [b][lindex $args 1]@[lindex $args 2][b] of [lindex $args 11] racers, [lindex $args 4] files at [format "%.0f" [expr [lindex $args 3] / 1024]]MB) - (group:  [b][lindex $args 5][b] of [lindex $args 12] racers, [lindex $args 7] files at [format "%.0f" [expr [lindex $args 6] / 1024]]MB) - \[total:  [lindex $args 9] files at [format "%.0f" [expr [lindex $args 8] / 1024]]MB$duration\]"
        }
       }
     ZIPBAD: {
    #ZIPBAD: <user> <group> <filename>
       if $enabled(announce_zipbad) {
        set pf [rel [lindex $args 0]]
        if {$pf == 0} {continue}
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set user [lindex $args 1]
        set group [lindex $args 2]
        set filename [lindex $args 3]
        putlog "\[[b]$sitein[b]\] [b]BAD ZIP:[b] in [b]$filename[b] located in -$path- [b]$rel[b] by [b]$user[b] of [b]$group[b]"  
        sndall "\[[b]$sitein[b]\] [b]BAD ZIP:[b] in [b]$filename[b] located in -$path- [b]$rel[b] by [b]$user[b] of [b]$group[b]"
        if {$pnc == 1} {nukecheck $rel}
        }
       }
      NEWZIP: {
     #NEWZIP: <user> <count> <projectedsize>
       if $enabled(announce_newzip) {
        set pf [rel [lindex $args 0]]
        if {$pf == 0} {continue}
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set user [lindex $args 1]
        set count [lindex $args 2]
        set projectedsize [lindex $args 3]
        putlog "\[[b]$sitein[b]\] [b]NEW RELEASE:[b] -$path- [b]$rel [b]\[[b]$projectedsize[b][b]mb[b] in [b]$count[b] files expected by [b]$user[b]\]"   
        sndall "\[[b]$sitein[b]\] [b]NEW RELEASE:[b] -$path- [b]$rel [b]\[[b]$projectedsize[b][b]mb[b] in [b]$count[b] files expected by [b]$user[b]\]"
        if {$pnc == 1} {nukecheck $rel}
        }
       }
      PRE: {
     #PRE: <user> <group> <tagline> <disks> <size>
       if $enabled(announce_pre) {
        set pf [rel [lindex $args 0]] 
        if {$pf == 0} {continue}  
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set user [lindex $args 1]
        set group [lindex $args 2]
        set tagline [lindex $args 3]
        set disks [lindex $args 4]
        set size [lindex $args 5]
        if {$group == ""} {set group "NoGroup"}
        putlog "\[[b]$sitein\] [b]PRE-RELEASE:[b] by [b]$group[b] -$path- [b]$rel[b] with[b]$disks[b] disk(s) [b]($size)[b]"
        sndall "\[[b]$sitein\] [b]PRE-RELEASE:[b] by [b]$group[b] -$path- [b]$rel[b] with[b]$disks[b] disk(s) [b]($size)[b]"
        if {$pnc == 1} {nukecheck $rel}
        }
       }
      SFV: {
     #SFV: <user> <count> <filetype>
       if $enabled(announce_sfv) {
        set pf [rel [lindex $args 0]]
        if {$pf == 0} {continue}
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set user [lindex $args 1]
        set count [lindex $args 2]
        set filetype [lindex $args 3]
        putlog "\[[b]$sitein[b]\] [b]UPDATE:[b] -$path- [b]$rel[b] \[[b]SFV:[b] $count file(s) expected ---> $filetype.xxx \] by [b]$user[b]."
        sndall "\[[b]$sitein[b]\] [b]UPDATE:[b] -$path- [b]$rel[b] \[[b]SFV:[b] $count file(s) expected ---> $filetype.xxx \] by [b]$user[b]."
        if {$pnc == 1} {nukecheck $rel}
        }
       }
      INVITE:
     #INVITE: <user> <nickname> <group>
       if $enabled(site_invite) {
        global invitechan
        set nickname [lindex $args 0]
        set username [lindex $args 1]
        set group [lindex $args 2]
        putserv "PRIVMSG $invitechan :\037\<\037\002$invitechan\002\037\>\037 inviting \002($nickname by $username from $group)\002"
        putserv "INVITE $nickname $invitechan"
       }
      NUKE: {if $enabled(announce_nuke) {newnuke NUKE [lindex [rel [lindex $args 0]] 1] $args}}
      UNNUKE: {if $enabled(announce_unnuke) {newnuke UNNUKE [lindex [rel [lindex $args 0]] 1] $args}}
      DELETED: {
     #DELETED: <dir> <size in kb>

      #add the following line in barkeep's autodel script, just before it does `rm -fr'
      #echo `date +"%a %b %d %T %Y"` DELETED: "$OLDUP" `du -s $uploads/$OLDUP | awk '{print $1}'` >> /glftpd/ftp-data/logs/glftpd.log

          putlog "[b]$sitein[b] AUTO DELETE: [b][lindex $args 0][b] - (freed:  [b][lindex $args 1]KB[b])"
          sndall "[b]$sitein[b] AUTO DELETE: [b][lindex $args 0][b] - (freed:  [b][lindex $args 1]KB[b])"
	}
      DELDIR: {
     #DELDIR: <user> <group> <tagline>
       if $enabled(announce_delete) {
        set pf [rel [lindex $args 0]]
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        set user [lindex $args 1]
        set group [lindex $args 2]
        set tagline [lindex $args 3]
        if {$group == ""} {set group "NoGroup"}
	set position [lsearch $new_release $rel]
        putlog "\[[b]$sitein[b]\] [b]DELETED:[b] $path/$rel by [b]$user[b]."    
        sndall "\[[b]$sitein[b]\] [b]DELETED:[b] $path/$rel by [b]$user[b]."
     	if {  $position < 0 } {	continue }
	set new_release [concat [lrange $new_release 0 [expr $position - 1]] [lrange $new_release [expr $position + 1] end]]
       }
      }
    }
  }
  close $of
  snop
  set lastoct [file size $gllog]
}

proc newnuke {type dir args} {global cnuke lasttype lastdir
  set args [lindex $args 0]
  if {$type == $lasttype && $dir == $lastdir && $cnuke(shown) == 0} {
    append cnuke(nukee) "[lindex $args 2] ([lindex [lindex $args 3] 1]\002MB\002)\002,\002 "
  } else {
    snop
    set cnuke(type) $type
    set cnuke(dir) $dir
    set cnuke(nuker) [lindex $args 1]
    set cnuke(nukee) "[lindex $args 2] ([lindex [lindex $args 3] 1]\002MB\002)\002,\002 "
    set cnuke(mult) [lindex [lindex $args 3] 0]
    set cnuke(reason) [lindex $args 4]
    set cnuke(shown) 0
  }
  set lasttype $type
  set lastdir $dir
}
putlog "testnuke"
proc snop {} {global cnuke sitein dirlog_testchans
  if {$cnuke(shown) == 1} {return 0}
  if {[string match "REUP--*" $cnuke(reason)]} {return 0}
  set cnuke(nukee) [string trim $cnuke(nukee) "\002,\002 "]
  putlog "\002$sitein\002 : \002$cnuke(type) $cnuke(mult)x\002-\002 $cnuke(dir) (Nuker: \002$cnuke(nuker)\002 Nukee(s): \002$cnuke(nukee)\002 Reason: \002$cnuke(reason)\002)"
  sndall "\002$sitein\002 : \002$cnuke(type) $cnuke(mult)x\002-\002 $cnuke(dir) (Nuker: \002$cnuke(nuker)\002 Nukee(s): \002$cnuke(nukee)\002 Reason: \002$cnuke(reason)\002)"
  set cnuke(shown) 1
}

if {[lsearch [utimers] "* scanlog *"] == -1} {
  utimer $timer(chk) "scanlog"
}

if {![array exists cnuke]} {set cnuke(dir) new ; set cnuke(type) new ; set cnuke(shown) 1 ; set lasttype "" ; set lastdir ""}
if {![info exists lastups]} {set lastups ""}
if {![info exists lastoct]} {set lastoct [file size $gllog]}

set new_release ""

putlog "- Site Announce by VR_DUDE mod'ed by JabberA and DaRKHeaRT Loaded!"

}

#######################################################
#################### STATS SCRIPT #####################
#######################################################

if $enabled(stats) {

#ONJOIN
bind join - * siteonjoin

proc siteonjoin {nick uhost hand chan} {global sonjoin sitein prefix dirlog_testchans
  if {$sonjoin != "1"} {return 0}
  if {[lsearch [string tolower $dirlog_testchans] [string tolower $chan]] == -1} {return 0}
  putnot $nick "[b]\[[b]$sitein[b]\][b] Type [b]${prefix}help[b] to view the list of commands"
}

#MAIN STATS
bind pub - ${prefix} pub_stats

proc pub_stats { nick uhost hand chan arg } {
 putlog $arg
 global sitename sitein dirlog_testchans output ver sitedir prefix
 
 set _section [string tolower [lindex $arg 0]]
 set cmd [string tolower [lindex $arg 1]]

 if [info exists sitedir($_section)] {
   set dir $sitedir($_section)
   set section [string toupper $_section]
   set cmd [lindex $arg 1]
  } {
   putnm $nick "Sorry, there is no section named $_section"
   putnm $nick "Valid sections are: [array names sitedir]"
   return 0
 }

 switch -exact -- $cmd {
    "wkup" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section WEEKTOP-\002 Request for $nick"}
        FTP::Cd $dir
        set result [FTP::Site wkup]
        foreach line $result { putnm $nick $line } ;
  } "wkdn" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section WEEK DOWN-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site wkdn]
        foreach line $result { putnm $nick $line } ;
  } "alup" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section ALLTIME WEEKTOP-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site alup]
        foreach line $result { putnm $nick $line } ;
  } "aldn" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section ALLTIME DOWNLOADERS-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site aldn]
        foreach line $result { putnm $nick $line } ;
  } "gpwk" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section GROUP WEEKTOP-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site gpwk]
        foreach line $result { putnm $nick $line } ;
  } "gpal" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section GROUP ALLTIME TOP-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site gpal]
        foreach line $result { putnm $nick $line } ;
  } "gpwd" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section GROUP WEEKTOP DOWN-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site gpwd]
        foreach line $result { putnm $nick $line } ;
  } "gpad" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section GROUP ALLTIME DOWN-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site gpad]
        foreach line $result { putnm $nick $line } ;
  } "dayup" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section DAYTOP UP-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site dayup]
        foreach line $result { putnm $nick $line } ;
  } "daydn" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section DAYTOP DOWN-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site daydn]
        foreach line $result { putnm $nick $line } ;
  } "monthup" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section MONTH TOP-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site monthup]
        foreach line $result { putnm $nick $line } ;
  } "monthdn" {
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section MONTH DOWN-\002 Request For $nick"}
        FTP::Cd $dir
        set result [FTP::Site monthdn]
        foreach line $result { putnm $nick $line } ;
  } "new" {
        set num [lindex $arg 2]
        if { $num == "" } { putnm $nick "Usage: $prefix $_section new <#number> - For last <#number> Uploads" ; return 0}
        if { $num < 100 } { foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-$section RECENT UPLOADS-\002 Request for $nick" }
        FTP::Cd $dir
        set result [FTP::Site "new $num"]
        foreach line $result { putnm $nick $line } ;
   }
  }
 default {putnm "$cmd is not valid. type ${prefix}help"}
 }
}

#DUPE
bind pub - ${prefix}dupe pub_dupe

proc pub_dupe { nick uhost hand chan args } {
global sitename sitein prefix dirlog_testchans output
        set string [lindex $args 0]
        if { $string == "" } {putnm $nick Usage "${prefix}dupe <string>" ; return 0 }
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-DUPE-\002 Request for $nick" }
        set result [FTP::Site "dupe $string 50"]
        foreach line $result { putnm $nick $line } ;
}

#WHO

bind pub - ${prefix}who pub_who

proc pub_who {nick host handle channel text} {
global sitename sitein dirlog_testchans output
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-WHO-\002 Request For $nick"}
        set result [FTP::Site who]
        foreach line $result { putnm $nick $line } ;
}

#LASTON
bind pub - ${prefix}laston pub_laston

proc pub_laston {nick host handle channel text} {
global sitename sitein dirlog_testchans output
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-LAST ON-\002 Request For $nick"}
        set result [FTP::Site laston]
        foreach line $result { putnm $nick $line } ;
}

#SEEN
bind pub - ${prefix}seen pub_seen

proc pub_seen { nick uhost hand chan args } {
global sitename sitein prefix dirlog_testchans output
        set user [lindex $args 0]
        if { $user == "" } {putnm $nick Usage "${prefix}seen <username>" ; return 0 }
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-SITE SEEN $user-\002 Request for $nick" }
        set result [FTP::Site "seen $user"]
        foreach line $result { putnm $nick $line } ;
}


#SEARCH
bind pub - ${prefix}search pub_search

proc pub_search { nick uhost hand chan args } {
global sitename sitein prefix dirlog_testchans output
	set string [lindex $args 0]
        if { $string == "" } {putnm $nick Usage "${prefix}search <String> - To search dirs on the site for <String>" ; return 0 }
	foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-DIRECTORY SEARCH-\002 Request for $nick" }
	set result [FTP::Site "search $string"]
        foreach line $result { putnm $nick $line } ;
}

#FREE
bind pub - ${prefix}free msdf

proc msdf {nick uhost hand chan args} {vrsdf 1 $nick [lindex $args 0]}
proc vrsdf {otf nick args} {global glftpddir sitein dirlog_testchans
  foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-SITE FREE-\002 Request for $nick" }
  set plen 5
  foreach part [lrange [split [exec /bin/df] \n] 1 end] {
    set parts([lindex $part 5]) [lrange $part 1 3]
  }
  if {[lsearch [array names parts] $glftpddir] != -1} {
    set show $glftpddir} else {set show /
  }
  foreach part [array names parts] {
    if {[string match $glftpddir/* $part]} {
      lappend show $part
      if {[string length $part] > $plen} {set plen [string length $part]}
    }
  }
  set plen [expr $plen - [string length $glftpddir]]
  putnm $nick "\([b]$sitein[b]\) [b]Free Space:[b]"
  foreach part [lsort $show] {
    regsub $glftpddir/ $part {/} glpath
    regsub $glftpddir $glpath {/} glpath
    putnm $nick "[format "%-${plen}s  FREE: %8s of %8s" $glpath [fixsize [lindex $parts($part) 2]] [fixsize [lindex $parts($part) 0]]]"
  }
}

#NUKETOP
bind pub - ${prefix}nuketop pub_nuketop

proc pub_nuketop { nick uhost hand chan args } {
global sitename sitein prefix dirlog_testchans output
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-SITE NUKETOP-\002 Request for $nick" }
        set result [FTP::Site "nuketop"]
        foreach line $result { putnm $nick $line } ;
}

#NUKES
bind pub - ${prefix}nukes pub_nukes

proc pub_nukes { nick uhost hand chan args } {
global sitename sitein prefix dirlog_testchans output
	set num [lindex $args 0]
        if { $num == "" } {putnm $nick "Usage: ${prefix}nukes <#number> - For last <#number> Nukes" ; return 0}
	if { $num < 100 } {foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-RECENT NUKES-\002 Request for $nick"}
		set result [FTP::Site "nukes $num"]
                foreach line $result { putnm $nick $line } ;
	}
}

#TRAFFIC
bind pub - ${prefix}traffic pub_traffic

proc pub_traffic {nick host handle channel text} {
global dirlog_testchans output sitename sitein
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-SITE TRAFFIC-\002 Request For $nick"}
        set result [FTP::Site traffic]
        foreach line $result { putnm $nick $line } ;
}

#USAGE
bind pub - ${prefix}usage pub_bwusage
proc pub_bwusage {nick host handle channel text} {
        global sitein dirlog_testchans
        set result [exec /glftpd/bin/bandwidth]
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] BANDWIDTH-\002 $result"}
}


#RULES
bind pub - ${prefix}rules pub_rules

proc pub_rules {nick host handle channel text} {
global dirlog_testchans output sitename sitein
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-SITE RULES-\002 Request For $nick"}
        set result [FTP::Site rules]
        foreach line $result { putnm $nick $line } ;
}

#USER
bind pub - ${prefix}user pub_user
proc pub_user {nick host handle channel text} {
global sitename sitein dirlog_testchans output
	set statnick [lindex $text 0]
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-SITE USER $statnick-\002 For $nick"}
	set result [FTP::Site "user $statnick"] 
        if {[string match "*nable to load*" $result]} { putnm $nick "User: $statnick doesnt exist" ; return 0 }

        set line1 [lindex $result 0] ; set line2 [lindex $result 1] ; set line3 [lindex $result 2] ; set line4 [lindex $result 3]
        set line5 [lindex $result 4] ; set line6 [lindex $result 5] ; set line7 [lindex $result 6] ; set line8 [lindex $result 7]
        set line9 [lindex $result 8] ; set line10 [lindex $result 9] ; set line11 [lindex $result 10] ; set line12 [lindex $result 11]
        set line13 [lindex $result 12] ; set line14 [lindex $result 13] ; set line15 [lindex $result 14]

        set userline [string trim [string trim [lrange $line3 1 end] "|"] " "]
        set tagline [string trim [string trim [lrange $line4 1 end] "|"] " "]
        set flagline [string trim [string trim [lrange $line5 1 end] "|"] " "]
        set createdline [string trim [string trim [lrange $line6 1 end] "|"] " "]
        set groupline [string trim [string trim [lrange $line7 1 end] "|"] " "]
        set privgroupline [string trim [string trim [lrange $line8 1 end] "|"] " "]
        set ratioline [string trim [string trim [lrange $line9 1 end] "|"] " "]
        set creditsline [string trim [string trim [lrange $line10 1 end] "|"] " "]
        set loginsline [string trim [string trim [lrange $line11 1 end] "|"] " "]
        set maxloginsline [string trim [string trim [lrange $line12 1 end] "|"] " "]
        set timesnukedline [string trim [string trim [lrange $line15 1 end] "|"] " "]

        putnm $nick "+--------------------------------+"
        putnm $nick "| [format %30s $userline] |"
        putnm $nick "+--------------------------------+"
#        putnm $nick "| [format %30s $flagline] |"
#        putnm $nick "| [format %30s $tagline] |"
        putnm $nick "| [format %30s $groupline] |"
#        putnm $nick "| [format %30s $privgroupline] |"
        putnm $nick "| [format %30s $ratioline] |"
        putnm $nick "| [format %30s $creditsline] |"
        putnm $nick "| [format %30s $loginsline] |"
#        putnm $nick "| [format %30s $timesnukedline] |"
        putnm $nick "| [format %30s $maxloginsline] |"
        putnm $nick "| [format %30s $createdline] |"
        putnm $nick "+--------------------------------+"
}


#VER
bind pub - ${prefix}ver pub_ver

proc pub_ver { nick uhost hand chan args } {
global sitename sitein ver dirlog_testchans 
        foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Using \002-$ver-\002 by DaRKHeaRT"}
}

#HELP

bind pub - ${prefix}help pub_help

proc pub_help {nick host handle channel text} {
global sitename sitein prefix ver dirlog_testchans output sitedir
	foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] Processing \002-HELP-\002 Request For $nick"}
        putnm $nick "$sitename Help."
        putnm $nick "--------------------------------------------------------------"
        putnm $nick "Public Commands for $ver by DaRKHeaRT"
        putnm $nick "--------------------------------------------------------------"
        putnm $nick "${prefix}ver                 - Show Version."
        putnm $nick "${prefix}rules               - Site Rules."
        putnm $nick "${prefix} <section> wkup     - Weeks Top Uploaders."
        putnm $nick "${prefix} <section> wkdn     - Weeks Top Downloaders."
        putnm $nick "${prefix} <section> gpwk     - Weeks Top Groups Up."
        putnm $nick "${prefix} <section> gpwd     - Weeks Top Groups Down."
        putnm $nick "${prefix} <section> alup     - Alltime Top Uploaders."
        putnm $nick "${prefix} <section> aldn     - Alltime Top Downloaders."
        putnm $nick "${prefix} <section> gpal     - Alltime Top Group Uploads."
        putnm $nick "${prefix} <section> gpad     - Alltime Top Group Downloads."
        putnm $nick "${prefix} <section> dayup    - Today's Top Uploaders."
        putnm $nick "${prefix} <section> daydn    - Today's Top Downloaders."
        putnm $nick "${prefix} <section> monthup  - Top Uploaders For The Month."
        putnm $nick "${prefix} <section> monthdn  - Top Downloaders For The Month."
        putnm $nick "${prefix} <section> new <#>  - Last <#number> Uploads."
        putnm $nick "${prefix}nuketop             - View NukeTop Stats."
        putnm $nick "${prefix}free                - Show Free Space on site."
        putnm $nick "${prefix}who                 - Whos Online and What are They Doing."
        putnm $nick "${prefix}traffic             - View site traffic."
        putnm $nick "${prefix}laston              - Last 10 Logins."
        putnm $nick "${prefix}search <string>     - Search for directories containing <string>."
        putnm $nick "${prefix}dupe <searchstring> - Search the Dupe datebase."
        putnm $nick "${prefix}seen <login>        - Show When User was last Logged on."
        putnm $nick "${prefix}nukes <#number>     - Last <#number> Nukes."
        putnm $nick "${prefix}user <login>        - Show Stats on a User."
        putnm $nick "${prefix}usage               - Show Bandwidth in Use."
        putnm $nick "--------------------------------------------------------------"
        putnm $nick "Valid sections are: [array names sitedir]"
        putnm $nick "--------------------------------------------------------------"
}
putlog "- Site Stats by DaRKHeaRT Loaded!"
}

#######################################################
##################### DCC SCRIPT ######################
#######################################################

if $enabled(dcc) {

#TRANSFER
bind dcc C ${dcc_prefix}transfer dcc_transfer

proc dcc_transfer {hand idx arg} {
global logfile dcc_prefix sitedir
        putlog "#$hand# transfer $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - TRANSFER $arg" ; close $fd
        set user [lindex $arg 0]
        set section1 [lindex $arg 1]
        set section2 [lindex $arg 2]
        set credits [lindex $arg 3]

        if { $user == "" } {putdcc $idx "Usage: .${dcc_prefix}transfer <username> <section1> <section2> <mb>" ; return 0 }
        if { $section1 == "" } {putdcc $idx "Usage: .${dcc_prefix}transfer <username> <section1> <section2> <mb>" ; return 0 }
        if { $section2 == "" } {putdcc $idx "Usage: .${dcc_prefix}transfer <username> <section1> <section2> <mb>" ; return 0 }
        if { $credits == "" } {putdcc $idx "Usage: .${dcc_prefix}transfer <username> <section1> <section2> <mb>" ; return 0 }
        set amount [expr $credits * 1024]
        if [info exists sitedir($section1)] {set dir1 $sitedir($section1)} {putdcc $idx "Sorry, there is no section named $section1 : Valid sections are: [array names sitedir]" ; return 0 }
        if [info exists sitedir($section2)] {set dir2 $sitedir($section2)} {putdcc $idx "Sorry, there is no section named $section2 : Valid sections are: [array names sitedir]" ; return 0 }

        set result [FTP::Cd $dir1] ; putdcc $idx "Change to section ($section1 : $dir1)"
        set result [FTP::Site "take $user $amount"] ; foreach line $result {putdcc $idx $line}
        set result [FTP::Cd $dir2] ; putdcc $idx "Change to section ($section2 : $dir2)"
        set result [FTP::Site "give $user $amount"] ; foreach line $result {putdcc $idx $line}
}       

#MSGAUTHOR
bind dcc - ${dcc_prefix}msgauthor dcc_msgauthor

proc dcc_msgauthor {hand idx arg} {

if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }

global sitename sitein logfile botnick from email

        set from $hand
        set email [lindex $arg 0]

        set head "$sitename - $sitein" ; regsub -all " " $head + hed
        set msg [lrange $arg 1 end] ; regsub -all " " $msg + mssg

        if { $email == "" } {putdcc $idx "Usage: .msgauthor <youremail> <message>" ; return 0 }
        if { $msg == "" } {putdcc $idx "Usage: .msgauthor <youremail> <message>" ; return 0 }

        putlog "#$hand# Sending Message \"$msg\" "

        set body $hed
        append body $mssg
        set var $body
        append var $hand
        append var $botnick
        set l [string length $var]
        set ln [expr $l + 41]
        
        go_connect $body $ln $mssg $hed

        putdcc $idx "#$hand# Message successfully sent to DaRKHeaRT"
        return 1
}

proc go_connect {body ln mssg hed} {
        global from email botnick $body $ln $mssg $hed 
        if [catch {socket "wwp.icq.com" 80} sockresult] { putlog "Could not connect:  $sockresult" ; return 0 }
        putlog "Socket $sockresult was opened"

  fconfigure $sockresult -translation auto -buffering line -blocking 0
        puts $sockresult "POST /scripts/WWPMsg.dll HTTP/1.1"
        puts $sockresult "Accept: application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*"
        puts $sockresult "Referer: http://nothing.com"
        puts $sockresult "Accept-Language: en-u"
        puts $sockresult "s"
        puts $sockresult "Content-Type: application/x-www-form-urlencoded"
        puts $sockresult "Accept-Encoding: gzip, deflate"
        puts $sockresult "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows 95)"
        puts $sockresult "Host: x"
        puts $sockresult "Content-Length: $ln"
        puts $sockresult "Connection: Keep-Alive"
        puts $sockresult ""
        puts $sockresult "subject=$hed&to=3744675&from=$from&fromemail=$email&body=$mssg&x=90&y=50"
       close $sockresult
 return 1
}

#ADDUSER
bind dcc C ${dcc_prefix}adduser dcc_adduser

proc dcc_adduser {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# adduser $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - ADDUSER $arg" ; close $fd
        set user [lindex $arg 0]
        set pass [lindex $arg 1]
        set group [lindex $arg 2]
        set ip1 [lindex $arg 3]
        set ip2 [lindex $arg 4]
        set ip3 [lindex $arg 5]
        set ip4 [lindex $arg 6]
        set ip5 [lindex $arg 7]
        set ip6 [lindex $arg 8]
        set ip7 [lindex $arg 9]
        set ip8 [lindex $arg 10]
        if { $user == "" } {putdcc $idx    "Usage: .{dcc_prefix}adduser <username> <password> <group>" ; return 0 }
        if { $pass == "" } { putdcc $idx  "Usage: .{dcc_prefix}adduser <username> <password> <group>" ; return 0 }
        if { $group == "" } { putdcc $idx  "Usage: .{dcc_prefix}adduser <username> <password> <group>" ; return 0 }
        set result [FTP::Site "adduser $user $pass"]
    	  foreach line $result {putdcc $idx  $line}
        set result [FTP::Site "chgrp $user $group"]
	  foreach line $result {putdcc $idx  $line}
        set result [FTP::Site "addip $user $ip1"]
	  foreach line $result {putdcc $idx  $line}
        if { $ip2 == "" } { return 0 }
        set result [FTP::Site "addip $user $ip2"]
	  foreach line $result {putdcc $idx  $line}
        if { $ip3 == "" } { return 0 }
        set result [FTP::Site "addip $user $ip3"]
	  foreach line $result {putdcc $idx  $line}
        if { $ip4 == "" } { return 0 }
        set result [FTP::Site "addip $user $ip4"]
	  foreach line $result {putdcc $idx  $line}
        if { $ip5 == "" } { return 0 }
        set result [FTP::Site "addip $user $ip5"]
	  foreach line $result {putdcc $idx  $line}
        if { $ip6 == "" } { return 0 }
        set result [FTP::Site "addip $user $ip6"]
	  foreach line $result {putdcc $idx  $line}
        if { $ip7 == "" } { return 0 }
        set result [FTP::Site "addip $user $ip7"]
	  foreach line $result {putdcc $idx  $line}
        if { $ip8 == "" } { return 0 }
        set result [FTP::Site "addip $user $ip8"]
	  foreach line $result {putdcc $idx  $line}
}

#CHPASS
bind dcc C ${dcc_prefix}chpass dcc_chpass

proc dcc_chpass {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# chpass $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - CHPASS $arg" ; close $fd
	set user [lindex $arg 0]
	set pass [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}chpass <username> <password>" ; return 0 }
        if { $pass == "" } { putdcc $idx "Usage: .{dcc_prefix}chpass <username> <password>" ; return 0 }
	set result [FTP::Site "chpass $user $pass"]
	foreach line $result {putdcc $idx $line}
}

#CHGRP
bind dcc C ${dcc_prefix}chgrp dcc_chgrp

proc dcc_chgrp {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# chgrp $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - CHGRP $arg" ; close $fd
	set user [lindex $arg 0]
        set oldgroup [lindex $arg 1]
        set newgroup [lindex $arg 2]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}chgrp <username> <oldgroup> <newgroup>" ; return 0 }
        if { $oldgroup == "" } { putdcc $idx "Usage: .{dcc_prefix}chgrp <username> <oldgroup> <newgroup>" ; return 0 }
        set result [FTP::Site "chgrp $user $oldgroup"]
	foreach line $result {putdcc $idx $line}
        set result [FTP::Site "chgrp $user $newgroup"]
	foreach line $result {putdcc $idx $line}
}

#CHRATIO
bind dcc C ${dcc_prefix}chratio dcc_chratio

proc dcc_chratio {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# chratio $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - CHRATIO $arg" ; close $fd
	set user [lindex $arg 0]
        set newratio [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}chratio <username> <newratio>" ; return 0 }
        if { $newratio == "" } { putdcc $idx "Usage: .{dcc_prefix}chratio <username> <newratio>" ; return 0 }
        set result [FTP::Site "change $user ratio $newratio"]
	foreach line $result {putdcc $idx $line}
}

#CHLOGINS
bind dcc C ${dcc_prefix}chlogins dcc_chlogins

proc dcc_chlogins {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# chlogins $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - CHLOGINS $arg" ; close $fd
        set user [lindex $arg 0]
        set value [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}chlogins <user> <logins>" ; return 0 }
        if { $value == "" } { putdcc $idx "Usage: .{dcc_prefix}chlogins <user> <logins>" ; return 0 }
        set result [FTP::Site "change $user num_logins $value"]
	foreach line $result {putdcc $idx $line}
}

#DELUSER
bind dcc C ${dcc_prefix}deluser dcc_deluser

proc dcc_deluser {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# deluser $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - DELUSER $arg" ; close $fd
	set user [lindex $arg 0]
        if { $user == "" } {putdcc $idx    "Usage: .{dcc_prefix}deluser <username>" ; return 0 }
        set result [FTP::Site "deluser $user"]
	foreach line $result {putdcc $idx  $line}
}

#GIVE
bind dcc C ${dcc_prefix}give dcc_give

proc dcc_give {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# give $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - GIVE $arg" ; close $fd
	set user [lindex $arg 0]
        set credits [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}give <username> <credits>" ; return 0 }
        if { $credits == "" } { putdcc $idx "Usage: .{dcc_prefix}give <username> <credits>" ; return 0 }
        set amount [expr $credits * 1024]
        set result [FTP::Site "give $user $amount"]
	foreach line $result {putdcc $idx $line}
}

#TAKE
bind dcc C ${dcc_prefix}take dcc_take

proc dcc_take {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# take $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - TAKE $arg" ; close $fd
	set user [lindex $arg 0]
        set credits [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}take <username> <credits>" ; return 0 }
        if { $credits == "" } { putdcc $idx "Usage: .{dcc_prefix}take <username> <credits>" ; return 0 }
        set amount [expr $credits * 1024]
        set result [FTP::Site "take $user $amount"]
	foreach line $result {putdcc $idx $line}
}

#KILL
bind dcc C ${dcc_prefix}kill dcc_kill

proc dcc_kill {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# kill $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - KILL $arg" ; close $fd
        set pid [lindex $arg 0]
        if { $pid == "" } { putdcc $idx "Usage: .{dcc_prefix}kill <pid>" ; return 0 }
        set result [FTP::Site "kill $pid"]
	foreach line $result {putdcc $idx $line}
}

#CHFLAGS
bind dcc C ${dcc_prefix}chflags dcc_chflags

proc dcc_chflags {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# chflags $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - CHFLAG $arg" ; close $fd
        set user [lindex $arg 0]
        set flags [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}chflag <user> <+/-><flags>" ; return 0 }
        if { $flags == "" } { putdcc $idx "Usage: .{dcc_prefix}chflag <user> <+/-><flags>" ; return 0 }
        set result [FTP::Site "change $user flags $flags"]
	foreach line $result {putdcc $idx $line}
}

#CHSLOTS
bind dcc C ${dcc_prefix}chslots dcc_chslots

proc dcc_chslots {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# chslots $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - CHGRPSLOTS $arg" ; close $fd
        set user [lindex $arg 0]
        set slots [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}chslots <user> <slots>" ; return 0 }
        if { $slots == "" } { putdcc $idx "Usage: .{dcc_prefix}chslots <user> <slots>" ; return 0 }
        set result [FTP::Site "change $user group_slots $slots"]
	foreach line $result {putdcc $idx $line}
}

#CHUNFO
bind dcc C ${dcc_prefix}chunfo dcc_chunfo

proc dcc_chunfo {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# chunfo $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - CHTAGLINE $arg" ; close $fd
        set user [lindex $arg 0]
        set tagline [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}chunfo <user> <tagline>" ; return 0 }
        if { $tagline == "" } { putdcc $idx "Usage: .{dcc_prefix}chunfo <user> <tagline>" ; return 0 }
        set result [FTP::Site "change $user tagline $tagline"]
	foreach line $result {putdcc $idx $line}
}

#CHTLIMIT
bind dcc C ${dcc_prefix}chtlimit dcc_chtlimit

proc dcc_chitime {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# chtlimit $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - CHIDLETIME $arg" ; close $fd
        set user [lindex $arg 0]
        set newtime [lindex $arg 1]
        if { $user == "" } { putdcc $idx "Usage: .{dcc_prefix}chtlimit <user> <newtime>" ; return 0 }
        if { $newtime == "" } { putdcc $idx "Usage: .{dcc_prefix}chtlimit <user> <newtime>" ; return 0 }
        set result [FTP::Site "change $user time_limit $newtime"]
	foreach line $result {putdcc $idx $line}
}

#GRPADD
bind dcc C ${dcc_prefix}grpadd dcc_grpadd

proc dcc_grpadd {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# grpadd $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - GRPADD $arg" ; close $fd
        set group [lindex $arg 0]
        if { $group == "" } { putdcc $idx "Usage: .{dcc_prefix}grpadd <group>" ; return 0 }
        set result [FTP::Site "grpadd $group"]
	foreach line $result {putdcc $idx $line}
}

#GRPDEL
bind dcc C ${dcc_prefix}grpdel dcc_grpdel

proc dcc_grpdel {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# grpdel $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - GRPDEL $arg" ; close $fd
        set group [lindex $arg 0]
        if { $group == "" } { putdcc $idx "Usage: .{dcc_prefix}grpdel <group>" ; return 0 }
        set result [FTP::Site "grpdel $group"]
	foreach line $result {putdcc $idx $line}
}

#GRPNFO 
bind dcc C ${dcc_prefix}grpnfo dcc_grpnfo

proc dcc_grpnfo {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# grpnfo $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - GRPNFO $arg" ; close $fd
        set group [lindex $arg 0]
        set nfo [lindex $arg 1]
        if { $group == "" } { putdcc $idx "Usage: .{dcc_prefix}grpnfo <group> <nfo>" ; return 0 }
        if { $nfo == "" } { putdcc $idx "Usage: .{dcc_prefix}grpnfo <group> <nfo>" ; return 0 }
        set result [FTP::Site "grpnfo $group $nfo"]
	foreach line $result {putdcc $idx $line}
}

#GRPREN
bind dcc C ${dcc_prefix}grpren dcc_grpren

proc dcc_grpren {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# grpren $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - GRPREN $arg" ; close $fd
        set oldgroup [lindex $arg 0]
        set newgroup [lindex $arg 1]
        if { $oldgroup == "" } { putdcc $idx "Usage: .{dcc_prefix}grpren <oldgroup> <newgroup>" ; return 0 }
        if { $newgroup == "" } { putdcc $idx "Usage: .{dcc_prefix}grpren <oldgroup> <newgroup>" ; return 0 }
        set result [FTP::Site "grpren $oldgroup $newgroup"]
	foreach line $result {putdcc $idx $line}
}

#GRPLOG
bind dcc C ${dcc_prefix}grplog dcc_grplog

proc dcc_grplog {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# grplog $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - GRPLOG $arg" ; close $fd
        set group [lindex $arg 0]
        set logins [lindex $arg 1]
        if { $group == "" } { putdcc $idx "Usage: .{dcc_prefix}grplog <group> <logins>" ; return 0 }
        if { $logins == "" } { putdcc $idx "Usage: .{dcc_prefix}grplog <group> <logins>" ; return 0 }
        set result [FTP::Site "grplog $group $logins"]
	foreach line $result {putdcc $idx $line}
}


#DISABLE 
bind dcc C ${dcc_prefix}disable dcc_disable

proc dcc_disable {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# disable $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - DISABLE $arg" ; close $fd
        set user [lindex $arg 0]
        if { $user == "" } { putdcc $idx "Usage: .sdisable <username>" ; return 0 }
        set result [FTP::Site "change $user flags +6"]
	foreach line $result {putdcc $idx $line}
}

#ENABLE
bind dcc C ${dcc_prefix}enable dcc_enable

proc dcc_enable {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# enable $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - ENABLE $arg" ; close $fd
        set user [lindex $arg 0]
        if { $user == "" } { putdcc $idx "Usage: .senable <username>" ; return 0 }
        set result [FTP::Site "readd $user"]
	foreach line $result {putdcc $idx $line}
}

#SITE
bind dcc C ${dcc_prefix}site dcc_site

proc dcc_site {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# site $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - SITE $arg" ; close $fd
	set 1 [lindex $arg 0]
	set 2 [lindex $arg 1]
	set 3 [lindex $arg 2]
	set 4 [lindex $arg 3]
	set 5 [lindex $arg 4]
	set 6 [lindex $arg 5]
	set 7 [lindex $arg 6]
	set 8 [lindex $arg 7]
        if { $1 == "" } { putdcc $idx "Usage: site <1> <2> <3> ..." ; return 0 }
	if { $2 == "" } { 
		set result [FTP::Site "$1"]
                foreach line $result {putdcc $idx $line}
		return 0 
	}
	if { $3 == "" } { 
		set result [FTP::Site "$1 $2"]
                foreach line $result {putdcc $idx $line}
                return 0 
	}
	if { $4 == "" } { 
		set result [FTP::Site "$1 $2 $3"]
                foreach line $result {putdcc $idx $line}
                return 0 
	}
	if { $5 == "" } { 
		set result [FTP::Site "$1 $2 $3 $4"]
                foreach line $result {putdcc $idx $line}
                return 0 
	}
	if { $6 == "" } { 
		set result [FTP::Site "$1 $2 $3 $4 $5"]
                foreach line $result {putdcc $idx $line}
                return 0 
	}
	if { $7 == "" } { 
		set result [FTP::Site "$1 $2 $3 $4 $5 $6"]
                foreach line $result {putdcc $idx $line}
                return 0 
	}
	if { $8 == "" } { 
		set result [FTP::Site "$1 $2 $3 $4 $5 $7"]
                foreach line $result {putdcc $idx $line}
                return 0 
	}
	set result [FTP::Site "$1 $2 $3 $4 $5 $7 $8"]
	foreach line $result {putdcc $idx $line}
}

#PURGE
bind dcc C ${dcc_prefix}purge dcc_purge

proc dcc_purge {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# purge $arg"
        set username [lindex $arg 0]
        if { $username == "" } { putdcc $idx "Usage: {$dcc_prefix}purge <*|username>" ; return 0 }
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - PURGE" ; close $fd
        set result [FTP::Site "purge $username"]
	foreach line $result {putdcc $idx $line}
}

#WHO2
bind dcc C ${dcc_prefix}who2 dcc_who2

proc dcc_who2 {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# who2 $arg"
        set result [FTP::Site "swho"]
	foreach line $result {putdcc $idx $line}
}

#UCHANGES
bind dcc C ${dcc_prefix}uchanges dcc_uchanges

proc dcc_uchanges {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# uchanges"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - ACCESED UCHANGES LOG" ; close $fd
        set days [lindex $arg 0]
        if { $days == "" } { putdcc $idx "Usage: .suchanges <for last number of days>" ; return 0 }
        set result [FTP::Site "uchanges $days"]
	foreach line $result {putdcc $idx $line}
}

#LOGINS
bind dcc C ${dcc_prefix}logins dcc_logins

proc dcc_logins {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# logins"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - ACCESS TO LOGINS LOG" ; close $fd
        set days [lindex $arg 0]
        if { $days == "" } { putdcc $idx "Usage: .slogins <for last number of days>" ; return 0 }
        set result [FTP::Site "logins $days"]
	foreach line $result {putdcc $idx $line}
}

#LOG
bind dcc C ${dcc_prefix}log dcc_log
proc dcc_log {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# log"
        set fd [open "$logfile"]
	gets $fd line
	set end [eof $fd]
	while { $end != 1 } {
                putdcc $idx $line
		gets $fd line
		set end [eof $fd]
	}
	close $fd
}

############## COMMANDS STAFF ARE ABLE TO DO

#ADDIP
bind dcc - ${dcc_prefix}addip dcc_addip

proc dcc_addip {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile botnick
        putlog "#$hand# addip $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - ADDIP $arg" ; close $fd
	set user [lindex $arg 0]
	set 1 [lindex $arg 1]
	set 2 [lindex $arg 2]
	set 3 [lindex $arg 3]
	set 4 [lindex $arg 4]
        set 5 [lindex $arg 5]
        set 6 [lindex $arg 6]
        set 7 [lindex $arg 7]
        set 8 [lindex $arg 8]
        set 9 [lindex $arg 9]
        set 10 [lindex $arg 10]
        set 11 [lindex $arg 11]
        if { $user == "" } { putdcc $idx "Usage: .saddip <username> <ip1> <ip2> <ip3> <ip4> <ip5> ..." ; return 0 }
        if { $1 == "" } { putdcc $idx "Usage: .saddip <username> <ip1> <ip2> <ip3> <ip4> <ip5> ..." ; return 0 }
        if { $11 == "" } {} else { putdcc $idx "only 10 ips per user are supported under glftpd - adding the rest..." }
        set result [FTP::Site "addip $user $1"]
	foreach line $result {putdcc $idx $line}
	if { $2 == "" } { return 0 }
        set result [FTP::Site "addip $user $2"]
	foreach line $result {putdcc $idx $line}
	if { $3 == "" } { return 0 }
        set result [FTP::Site "addip $user $3"]
	foreach line $result {putdcc $idx $line}
	if { $4 == "" } { return 0 }
        set result [FTP::Site "addip $user $4"]
	foreach line $result {putdcc $idx $line}
        if { $5 == "" } { return 0 }
        set result [FTP::Site "addip $user $5"]
	foreach line $result {putdcc $idx $line}
        if { $6 == "" } { return 0 }
        set result [FTP::Site "addip $user $6"]
	foreach line $result {putdcc $idx $line}
        if { $7 == "" } { return 0 }
        set result [FTP::Site "addip $user $7"]
	foreach line $result {putdcc $idx $line}
        if { $8 == "" } { return 0 }
        set result [FTP::Site "addip $user $8"]
	foreach line $result {putdcc $idx $line}
        if { $9 == "" } { return 0 }
        set result [FTP::Site "addip $user $9"]
	foreach line $result {putdcc $idx $line}
        if { $10 == "" } { return 0 }
        set result [FTP::Site "addip $user $10"]
	foreach line $result {putdcc $idx $line}
}

#DELIP
bind dcc - ${dcc_prefix}delip dcc_delip

proc dcc_delip {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile botnick
        putlog "#$hand# delip $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - DELIP $arg" ; close $fd
 	set user [lindex $arg 0]
	set 1 [lindex $arg 1]
	set 2 [lindex $arg 2]
	set 3 [lindex $arg 3]
	set 4 [lindex $arg 4]
	set 5 [lindex $arg 5]
        set 6 [lindex $arg 6]
        if { $user == "" } { putdcc $idx "Usage: .sdelip <username> <ip1> <ip2> <ip3> <ip4> <ip5>" ; return 0 }
        if { $1 == "" } { putdcc $idx "Usage: .sdelip <username> <ip1> <ip2> <ip3> <ip4> <ip5>" ; return 0 }
        if { $6 == "" } {} else { putdcc $idx "only 5 ips supported at a time, sorry - adding the rest..." }
        set result [FTP::Site "delip $user $1"]
	foreach line $result {putdcc $idx $line}
	if { $2 == "" } { return 0 }
        set result [FTP::Site "delip $user $2"]
	foreach line $result {putdcc $idx $line}
	if { $3 == "" } { return 0 }
        set result [FTP::Site "delip $user $3"]
	foreach line $result {putdcc $idx $line}
	if { $4 == "" } { return 0 }
        set result [FTP::Site "delip $user $4"]
	foreach line $result {putdcc $idx $line}
        if { $5 == "" } { return 0 }
        set result [FTP::Site "delip $user $5"]
	foreach line $result {putdcc $idx $line}
}

#GINFO 
bind dcc - ${dcc_prefix}ginfo dcc_ginfo

proc dcc_ginfo {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile botnick
        putlog "#$hand# ginfo $arg"
        set group [lindex $arg 0]
        if { $group == "" } { putdcc $idx "Usage: .sginfo <group>" ; return 0 }
        set result [FTP::Site "ginfo $group"]
	foreach line $result {putdcc $idx $line}
}

#FLAGS
bind dcc - ${dcc_prefix}flags dcc_flags

proc dcc_flags {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile botnick
        putlog "#$hand# flags $arg"
        set user [lindex $arg 0]
        if { $user == "" } { putdcc $idx "Usage: .sflags <username> " ; return 0 }
        set result [FTP::Site "flags $user"]
	foreach line $result {putdcc $idx $line}
}

#USERS
bind dcc - ${dcc_prefix}users dcc_users

proc dcc_users {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile botnick
        putlog "#$hand# users $arg"
        set which [lindex $arg 0]
        if { $which == "" } { putdcc $idx "Usage: .susers <*|LEECH|SITEOP|GADMIN|DELETED>" ; return 0 }
        set result [FTP::Site "users $which"]
	foreach line $result {putdcc $idx $line}
}

#ANNOUNCE
bind dcc - ${dcc_prefix}announce dcc_announce

proc dcc_announce {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile dirlog_testchans
        putlog "#$hand# announce $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - ANNOUNCE $arg" ; close $fd
	foreach chan $dirlog_testchans {putchan $chan "\[\002$sitein\002\] \002-$hand: ANNOUNCEMENT-\002 $arg"}
}

#UNDUPE 
bind dcc - ${dcc_prefix}undupe dcc_undupe

proc dcc_undupe {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] && ![matchattr $hand N]} { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# undupe $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - UNDUPE $arg" ; close $fd
        set file [lindex $arg 0]
        if { $file == "" } { putdcc $idx "Usage: .${dcc_prefix}undupe <filename>" ; return 0 }
        set result [FTP::Site "undupe $file"]
	foreach line $result {putdcc $idx $line}
}

#NUKE
bind dcc - ${dcc_prefix}nuke dcc_nuke

proc dcc_nuke {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] && ![matchattr $hand N] } { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile botnick dcc_prefix today sitedir
        putlog "#$hand# nuke $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - NUKE $arg" ; close $fd
        set where [lindex $arg 0]
        set release [lindex $arg 1]
        set x [lindex $arg 2]
	set reason [lindex $arg 3]
        if { $where == "" } { putdcc $idx "Usage: .${dcc_prefix}nuke <where|today> <dir> <times> <reason>" ; return 0 }
        if { $release == "" } { putdcc $idx "Usage: .${dcc_prefix}nuke <where|today> <dir> <times> <reason>" ; return 0 }
        if { $x == "" } { putdcc $idx "Usage: .${dcc_prefix}nuke <where|today> <dir> <times> <reason>" ; return 0 }
        if { $reason == "" } { putdcc $idx "Usage: .${dcc_prefix}nuke <where|today> <dir> <times> <reason>" ; return 0 }
        if {$where=="today"} {
                FTP::Cd $today
                set result [FTP::Site "nuke $release $x $reason"]
                foreach line $result {putdcc $idx $line}
	} else {
                FTP::Cd $where
                set result [FTP::Site "nuke $release $x $reason"]
                foreach line $result {putdcc $idx $line}
	}		
	FTP::Cd /
}

#UNNUKE
bind dcc - ${dcc_prefix}unnuke dcc_unnuke

proc dcc_unnuke {hand idx arg} {
if { ![matchattr $hand C] && ![matchattr $hand S] && ![matchattr $hand N] } { putdcc $idx "What?  You need '.help'" ; return 0 }
global sitename sitein logfile botnick dcc_prefix today
        putlog "#$hand# unnuke $arg"
        set fd [open "$logfile" a] ; puts $fd "[date]/[time] - $hand - UNNUKE $arg" ; close $fd
        set where [lindex $arg 0]
        set release [lindex $arg 1]
        set reason [lindex $arg 2]
        if { $where == "" } { putdcc $idx "Usage: .${dcc_prefix}unnuke <date> <dir> <reason>" ; return 0 }
        if { $release == "" } { putdcc $idx "Usage: .${dcc_prefix}unnuke <date> <dir> <reason>" ; return 0 }
        if { $reason == "" } { putdcc $idx "Usage: .${dcc_prefix}unnuke <date> <dir> <reason>" ; return 0 }
	if {$fd=="today"} {
                FTP::Cd $today
                set result [FTP::Site "unnuke $release $reason"]
                foreach line $result {putdcc $idx $line}
	} else {
                FTP::Cd $where
                set result [FTP::Site "unnuke $release $reason"]
                foreach line $result {putdcc $idx $line}
	}		
	FTP::Cd /
}

############## COMMANDS ANYONE CAN DO

#TIME
bind dcc - ${dcc_prefix}time dcc_time

proc dcc_time {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# time"
        set result [FTP::Site "time"]
	foreach line $result {putdcc $idx $line}
}

#GROUPS
bind dcc - ${dcc_prefix}groups dcc_groups

proc dcc_groups {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# groups"
        set result [FTP::Site "groups"]
	foreach line $result {putdcc $idx $line}
}

#RULES
bind dcc - ${dcc_prefix}rules dcc_rules

proc dcc_rules {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# rules"
        set result [FTP::Site "rules"]
	foreach line $result {putdcc $idx $line}
}

#USER
bind dcc - ${dcc_prefix}user dcc_user

proc dcc_user {hand idx arg} {
global sitename sitein logfile botnick dcc_prefix
        putlog "#$hand# user $arg"
        set user [lindex $arg 0]
        if { $user == "" } { putdcc $idx "Usage: .${dcc_prefix}user <username>" ; return 0 }
        set result [FTP::Site "user $user"]
	foreach line $result {putdcc $idx $line}
        set result [FTP::Site "stats $user"]
	foreach line $result {putdcc $idx $line}
}

#WHO
bind dcc - ${dcc_prefix}who dcc_who

proc dcc_who {hand idx arg} {
global sitename sitein logfile botnick
        putlog "#$hand# who $arg"
        set result [FTP::Site "who"]
	foreach line $result {putdcc $idx $line}
}

#HELP
bind dcc - ${dcc_prefix}help dcc_help

proc dcc_help {hand idx arg} {
global sitename sitein prefix dcc_prefix ver sitedir
        putlog "#$hand# help"
        putdcc $idx "\002STANDARD HELP-(PUBLIC & DCC)\002----${ver}----"
        putdcc $idx "------------------------------------------------------------"
        putdcc $idx "${prefix}ver                      - Show Version."
        putdcc $idx "${prefix}rules                    - Site Rules."
        putdcc $idx "${prefix} <section> wkup          - Weeks Top Uploaders."
        putdcc $idx "${prefix} <section> wkdn          - Weeks Top Downloaders."
        putdcc $idx "${prefix} <section> gpwk          - Weeks Top Groups Up."
        putdcc $idx "${prefix} <section> gpwd          - Weeks Top Groups Down."
        putdcc $idx "${prefix} <section> alup          - Alltime Top Uploaders."
        putdcc $idx "${prefix} <section> aldn          - Alltime Top Downloaders."
        putdcc $idx "${prefix} <section> gpal          - Alltime Top Group Uploads."
        putdcc $idx "${prefix} <section> gpad          - Alltime Top Group Downloads."
        putdcc $idx "${prefix} <section> dayup         - Today's Top Uploaders."
        putdcc $idx "${prefix} <section> daydn         - Today's Top Downloaders."
        putdcc $idx "${prefix} <section> monthup       - Top Uploaders For The Month."
        putdcc $idx "${prefix} <section> monthdn       - Top Downloaders For The Month."
        putdcc $idx "${prefix} <section> new <#number> - Last <#number> Uploads."
        putdcc $idx "${prefix}who                      - Whos Online and What are They Doing."
        putdcc $idx "${prefix}traffic                  - View site traffic."
        putdcc $idx "${prefix}laston                   - Last 10 Logins."
        putdcc $idx "${prefix}search <string>          - Search for directories containing <string>."
        putdcc $idx "${prefix}nukes <#number>          - Last <#number> Nukes."
        putdcc $idx "${prefix}user <login>             - Show Stats on a User."
        putdcc $idx "------------------------------------------------------------"
        putdcc $idx "Valid sections are: [array names sitedir]"
        putdcc $idx "------------------------------------------------------------"
        if { [matchattr $hand C] } {
        putdcc $idx "\002SITEOP HELP\002---------------------------------------------"
        putdcc $idx ".${dcc_prefix}announce <announcement>"
        putdcc $idx ".${dcc_prefix}addip    <user> <ip1> <ip2> <ip3> <ip4> <ip5> ..."
        putdcc $idx ".${dcc_prefix}adduser  <user> <password> <group> <ip1> <ip2> ..."
        putdcc $idx ".${dcc_prefix}delip    <user> <ip1> <ip2> <ip3> <ip4> <ip5>"
        putdcc $idx ".${dcc_prefix}deluser  <user>"
        putdcc $idx ".${dcc_prefix}chgrp    <user> <oldgroup> <newgroup>"
        putdcc $idx ".${dcc_prefix}chlogins <user> <max login>"
        putdcc $idx ".${dcc_prefix}chpass   <user> <new password>"
        putdcc $idx ".${dcc_prefix}chratio  <user> <ratio>"
        putdcc $idx ".${dcc_prefix}chslots  <user> <slots>"
        putdcc $idx ".${dcc_prefix}chunfo   <user> <tagline>"
        putdcc $idx ".${dcc_prefix}chflags  <user> <+/-><FLAGS>"
        putdcc $idx ".${dcc_prefix}chitime  <user> <new idle time>"
        putdcc $idx ".${dcc_prefix}disable  <user>"
        putdcc $idx ".${dcc_prefix}enable   <user>"
        putdcc $idx ".${dcc_prefix}flags    <user>"
        putdcc $idx ".${dcc_prefix}groups   (Display All Groups)"
        putdcc $idx ".${dcc_prefix}grpadd   <group>"
        putdcc $idx ".${dcc_prefix}grpdel   <group>"
        putdcc $idx ".${dcc_prefix}grplog   <group> <num>"
        putdcc $idx ".${dcc_prefix}grpnfo   <group> <info>"
        putdcc $idx ".${dcc_prefix}grpren   <group> <newgroup>"
        putdcc $idx ".${dcc_prefix}ginfo    <group>"
        putdcc $idx ".${dcc_prefix}give     <user> <mbs>"
        putdcc $idx ".${dcc_prefix}help     (This Window)"
        putdcc $idx ".${dcc_prefix}kill     <pid>"
        putdcc $idx ".${dcc_prefix}logins   <how many days to show> (Logins Log)"
        putdcc $idx ".${dcc_prefix}log      (Log of Changes Made Through bot)"
        putdcc $idx ".${dcc_prefix}msgauthor <youremail> <message>"
        putdcc $idx ".${dcc_prefix}nuke     <today|date> <dir> <x> <reason>"
        putdcc $idx ".${dcc_prefix}purge    <*/username> (Clear Database of Users Flagged For Deletion)"
        putdcc $idx ".${dcc_prefix}rules    (Site Rules)"
        putdcc $idx ".${dcc_prefix}site     <whatever>"
        putdcc $idx ".${dcc_prefix}take     <user> <mbs>"
        putdcc $idx ".${dcc_prefix}time     (Display Local Time And Stat Reset Times)"
        putdcc $idx ".${dcc_prefix}transfer <user> <section1> <section2> <mbs>"
        putdcc $idx ".${dcc_prefix}uchanges <how many days to show> (User Changes Log)"
        putdcc $idx ".${dcc_prefix}undupe   <filename>"
        putdcc $idx ".${dcc_prefix}unnuke   <today|date> <dir> <reason>"
        putdcc $idx ".${dcc_prefix}user     <username>"
        putdcc $idx ".${dcc_prefix}users    <*/LEECH/GADMIN/SITEOP/USEREDIT> etc.."
        putdcc $idx ".${dcc_prefix}who      (Display Whos Connected)"
        putdcc $idx ".${dcc_prefix}who2     (Display Whos Connected With PIDS)"
        putdcc $idx "---------------------------------------------------------------------"
        } elseif { [matchattr $hand S] } {
        putdcc $idx "\002STAFF HELP\002----------------------------------------------"
        putdcc $idx ".${dcc_prefix}addip    <user> <ip1> <ip2> <ip3> <ip4> <ip5>"
        putdcc $idx ".${dcc_prefix}announce <announcement>"
        putdcc $idx ".${dcc_prefix}delip    <user> <ip1> <ip2> <ip3> <ip4> <ip5>"
        putdcc $idx ".${dcc_prefix}flags    <user>"
        putdcc $idx ".${dcc_prefix}ginfo    <group>"
        putdcc $idx ".${dcc_prefix}groups   (Display All Groups)"
        putdcc $idx ".${dcc_prefix}help     (This Window)"
        putdcc $idx ".${dcc_prefix}msgauthor <youremail> <message>"
        putdcc $idx ".${dcc_prefix}nuke     <where|today> <dir> <x> <reason>"
        putdcc $idx ".${dcc_prefix}rules    (Site Rules)"
        putdcc $idx ".${dcc_prefix}time     (Display Local Time And Stat Reset Times)"
        putdcc $idx ".${dcc_prefix}undupe   <filename>"
        putdcc $idx ".${dcc_prefix}unnuke   <where|today> <dir> <reason>"
        putdcc $idx ".${dcc_prefix}user     <username>"
        putdcc $idx ".${dcc_prefix}users    <*/LEECH/GADMIN/SITEOP/USEREDIT> etc.."
        putdcc $idx ".${dcc_prefix}who      (Display Whos Connected)"
        putdcc $idx "---------------------------------------------------------------------"
        } elseif { [matchattr $hand N] } {
        putdcc $idx "\002NUKER HELP\002---------------------------------------------"
        putdcc $idx ".${dcc_prefix}undupe   <filename>"
        putdcc $idx ".${dcc_prefix}nuke     <where|today> <release> <x> <reason>"
        putdcc $idx ".${dcc_prefix}unnuke   <where|today> <release> <reason>"
        putdcc $idx ".${dcc_prefix}groups   (Display All Groups)"
        putdcc $idx ".${dcc_prefix}help     (This Window)"
        putdcc $idx ".${dcc_prefix}rules    (Site Rules Contains Nuking Chart)"
        putdcc $idx ".${dcc_prefix}time     (Display Local Time And Stat Reset Times)"
        putdcc $idx ".${dcc_prefix}user     <username>"
        putdcc $idx ".${dcc_prefix}who      (Display Whos Connected)"
        putdcc $idx "---------------------------------------------------------------------"
        } else {
        putdcc $idx "\002GENERAL HELP\002----------------------------------------------"
        putdcc $idx ".${dcc_prefix}groups   (Display All Groups)"
        putdcc $idx ".${dcc_prefix}help     (This Window)"
        putdcc $idx ".${dcc_prefix}rules    (Site Rules Contains Nuking Chart)"
        putdcc $idx ".${dcc_prefix}time     (Display Local Time And Stat Reset Times)"
        putdcc $idx ".${dcc_prefix}user     <username>"
        putdcc $idx ".${dcc_prefix}who      (Display Whos Connected)"
        putdcc $idx "---------------------------------------------------------------------"
        }
}
putlog "- Site DCC Components by DaRKHeaRT Loaded!"
}

proc sitebot:addversion { addonver } {
        global ver
        set ver "$ver +$addonver"
}

putlog "$sitein $ver SUCCESSFULLY LOADED -- BY DaRKHeaRT(rhett@lotus-net.ch)"

putlog "- Searching for sitebot addons )"
if {[catch { set scripts [glob scripts/sitebot-addon-*.tcl] } ] != 0 } { putlog "- no sitebot addons found" } {
        foreach script $scripts {
                putlog "  - Loading $script"
                source $script
        }
}

